<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ManufacturingOperationTaskSearch StructType
 * @subpackage Structs
 */
class ManufacturingOperationTaskSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ManufacturingOperationTaskSearchBasic
     */
    public $basic;
    /**
     * The predecessorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ManufacturingOperationTaskSearchBasic
     */
    public $predecessorJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchBasic
     */
    public $userJoin;
    /**
     * The workOrderJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchBasic
     */
    public $workOrderJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchJoin[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for ManufacturingOperationTaskSearch
     * @uses ManufacturingOperationTaskSearch::setBasic()
     * @uses ManufacturingOperationTaskSearch::setPredecessorJoin()
     * @uses ManufacturingOperationTaskSearch::setUserJoin()
     * @uses ManufacturingOperationTaskSearch::setWorkOrderJoin()
     * @uses ManufacturingOperationTaskSearch::setCustomSearchJoin()
     * @param \StructType\ManufacturingOperationTaskSearchBasic $basic
     * @param \StructType\ManufacturingOperationTaskSearchBasic $predecessorJoin
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @param \StructType\TransactionSearchBasic $workOrderJoin
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     */
    public function __construct(\StructType\ManufacturingOperationTaskSearchBasic $basic = null, \StructType\ManufacturingOperationTaskSearchBasic $predecessorJoin = null, \StructType\EmployeeSearchBasic $userJoin = null, \StructType\TransactionSearchBasic $workOrderJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setPredecessorJoin($predecessorJoin)
            ->setUserJoin($userJoin)
            ->setWorkOrderJoin($workOrderJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\ManufacturingOperationTaskSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\ManufacturingOperationTaskSearchBasic $basic
     * @return \StructType\ManufacturingOperationTaskSearch
     */
    public function setBasic(\StructType\ManufacturingOperationTaskSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get predecessorJoin value
     * @return \StructType\ManufacturingOperationTaskSearchBasic|null
     */
    public function getPredecessorJoin()
    {
        return $this->predecessorJoin;
    }
    /**
     * Set predecessorJoin value
     * @param \StructType\ManufacturingOperationTaskSearchBasic $predecessorJoin
     * @return \StructType\ManufacturingOperationTaskSearch
     */
    public function setPredecessorJoin(\StructType\ManufacturingOperationTaskSearchBasic $predecessorJoin = null)
    {
        $this->predecessorJoin = $predecessorJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @return \StructType\ManufacturingOperationTaskSearch
     */
    public function setUserJoin(\StructType\EmployeeSearchBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get workOrderJoin value
     * @return \StructType\TransactionSearchBasic|null
     */
    public function getWorkOrderJoin()
    {
        return $this->workOrderJoin;
    }
    /**
     * Set workOrderJoin value
     * @param \StructType\TransactionSearchBasic $workOrderJoin
     * @return \StructType\ManufacturingOperationTaskSearch
     */
    public function setWorkOrderJoin(\StructType\TransactionSearchBasic $workOrderJoin = null)
    {
        $this->workOrderJoin = $workOrderJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchJoin[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $manufacturingOperationTaskSearchCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$manufacturingOperationTaskSearchCustomSearchJoinItem instanceof \StructType\CustomSearchJoin) {
                $invalidValues[] = is_object($manufacturingOperationTaskSearchCustomSearchJoinItem) ? get_class($manufacturingOperationTaskSearchCustomSearchJoinItem) : sprintf('%s(%s)', gettype($manufacturingOperationTaskSearchCustomSearchJoinItem), var_export($manufacturingOperationTaskSearchCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     * @return \StructType\ManufacturingOperationTaskSearch
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin $item
     * @return \StructType\ManufacturingOperationTaskSearch
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchJoin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchJoin) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
